<?php
  /* File: spfconfig.cfg.php

Snippet:       SPForm
Version: 1.0.4
$Revision: 265 $
$Author: Bob Ray $
$Date: 2009-07-02 15:42:55 -0500 (Thu, 02 Jul 2009) $
Adapted from:  Many sources but particularly scform by James Seymour and CFFormProtect by Jake Munson
Compatibility: MODX 0.9.6, 0.9.7
*/

  // Configuration file for SPForm snippet

  // paths to config files
  $spformPath = "assets/snippets/spform/";
  $banListFile = $modx->config['base_path'].$spformPath."banlist.cfg.php";
  $recipientFile = $modx->config['base_path'].$spformPath."contacts.cfg.php";

  $test_mode = false; // set to true to run spform without actually sending mail

  // Set Language

  $lang = "en";

// crap up your screen with debugging info:
   $spfDebug = false; // WARNING: Don't leave this turned on a production site!!!

/* Simple Contact Form configuration

  ***********************************************************
  Things you should set before using the snippet
  ***********************************************************/
/*
 * This is used by the form processor, not the form Allowed referers -
 * domains/IPs you will allow this processor to be "called" from. You
 * probably want this to be, for example, the hostname of the host your
 * form page is on. If this is empty, *any* host can post to this script.
 * Then again: The HTTP REFERER is easily faked, and some firewalls and
 * HTTP proxies delete it, anyway. (See $formProcBlankRefOkay, above.) To
 * allow any referer, use $formProcAllowedReferers = array(); If you use
 * $chkFormRefOwnServer = true; (set below) Be sure you have all possible
 * variants here (e.g. domain.com, www.domain.com).
 */

$formProcAllowedReferers = array(
    'dklex.com','www.dklex.com',
	'localhost'
);

$spformProcID = 4;  // Doc ID of spformproc page
$spfResponseID = 5; // Doc ID of spfresponse page

// Whom to email regarding errors and such-like?  A space-comma-delimited
// list of email addresses.
$errorsTo = "dk@dklex.com";

/*
 * **************************************
 * Settings you can change or leave alone
 * ***************************************  */
 /*
 By default, SPForm uses mail() to send mail. If you change the following
 parameter to true, SPForm will use SMTP to send mail. To use SMTP, you must
 set the port, host, username and password.
 */

 $spfUseSMTP= false; // default false -- if this is false, the next four parameters are ignored

 if ($spfUseSMTP) {
	 $spfSMTP_Port = 587; // default port for authenticated e-mail - many hosts now block port 25.
	 $spfSMTP_Host = "smtp.your_isp.com";
	 $spfSMTP_UserName = "your_user_name";
	 $spfSMTP_Password = "your_password";
 }


 /*
 * Use hidden form field (idea suggested by RThrash) If this is true, a
 * "LastName" field will be added to your form and then hidden by the CSS
 * styling. If it's filled in (presumably by spammer autobots) nothing is
 * sent. The "hidden" content is not really hidden, just not visible, so no
 * worries about being penalized by Google. Visually challenged users of
 * text-only browsers or audio browsers MAY see the input field and fill it
 * (although the text warns them not to). It works like a charm.
 *
 *
 * IMPORTANT!!: If you set #useHiddenField to true, you need to paste the
 * following code into your CSS file (minus the comment tags). Otherwise
 * the field will not be hidden.
 */

/*

		.spform_input {
		position:absolute;
		text-decoration:underline;
		background-color:#CC0000;
		left:0px;
		top:-500px;
		width:1px;
		height:1px;
		overflow:hidden;
		}

*/
$useHiddenField = false;    //default false

/*
 * If $useHiddenField=true and $warnHiddenField=true, the user will be told
 * that they shoudn't have filled the field. if $useHiddenField=true and
 * $warnHiddenField=false, the script will exit with no warning if the
 * field is filled.
 */
$warnHiddenField = true;   // default true

// logs filled hidden form only if $warnHiddenField=false;
$logOnHidden = false; // default false

 /*
 * The following three variables require javascript to be on. There is no
 * warning here, the program just dies on the assumption that a form
 * without keyboard or mouse use is submitted directly by a spammer. The
 * first choice is recommended since some disabled users may be restricted
 * to either a mouse or keyboard. Presumably, voice- or muscle- operated
 * systems would simulate one or the other.
 */

 // requires mouse or keyboard or both (requires javascript)
// If this is true, the two variables below are ignored.
$requireMouseOrKeyboard = false;   // default false

$requireKeyboard = false;	// Require user to type something.  - default false
							// Requires javascript to be on.

$requireMouse = false;		// Require user to move mouse.  - default false
							// Requires javascript to be on.

$logMouseAndKeyboardErrors = true;  // log mouse and keyboard errors - default true

/*
 * if $useTimer=true, the user will be timed filling out the contact form.
 * taking too much or too little time will be an error. max and min
 * variables are in seconds. Note: A user who violates time or any other
 * check will press back to get to the form but their time won't be reset
 * unless they reload the form page. They are warned to do this on a timer
 * violation if $warnTimer=true, but if they make enough errors to get over
 * the time limit they'll have to re-load the page and lose their work.
 * That's why the default max is 30 minutes.
 */

$useTimer = false;   	// default false
$useTimerMin = 10;      // default 10 seconds
$useTimerMax = 30 * 60; // Default thirty minutes -- see note above.

$warnTimer = true;      // Warn user of time violation or die quietly.
                        // If on, the user is warned to go back and reload the form page
                        // to reset the timer (otherwise, the elapsed time will keep
                        // getting longer and longer). If you set this to false, you
                        // might want to raise $useTimerMax.

$timerOffset = 14543;   // obfuscates timer value
$logOnTimer=true;       // log timer violations   - default true

/*
 * Add distinctive prefix to "Subject:" in "[]" field? The "distinctive
 * prefix" will be the sole contents of the "Subject:" line, less the "[]",
 * if $requireSubj is false and there's no Subject.*/

$addSubjSig = true;     //default true

/*
 * Default "Subject:" line or "distinctive prefix" if $addSubjSig is true
 * and there's a subject provided, the subject line will have [your prefix]
 * followed by user's subject.
 * Example: $dfltSubj = "Sent from My Web Site";
 */
$dfltSubj = $_SERVER['SERVER_NAME'] . " contact";

/*
 * Location of spform auxilliary files -- you shouldn't have to change this
 * unless you move them. for ultra spam protection, you can place them
 * outside the site root
 */

// next four lines for debugging


  //$recipientFile = "contacts.cfg.php";
  //  echo "RecipientFile (in spfconfig): ",$recipientFile,"<br>";
  //  $banListFile = "banlist.cfg.php";
  //  echo "BanlistFile (in spfconfig): ",$banListFile,"<br>";


/*
 * Keep spammers from pasting too many links into your form and sending it
 * (counts "http" instances); If people send you lots of links in one
 * message, you'll want to change this.
 */
$maxLinks = 3;     // default 3

  //Longest allowed email address for recipients.
// Be sure it's as long as the longest email address in your contacts file
$maxRecipientLen = 65;     // default 65

// limit subject length. Helps short-circuit injection attacks
$maxSubjectLen = 100; //Longest allowed subject line - default 100

// A comma-delimited list of email addresses that'll be "Cc"d on
// anything to any of the regular recipients.
$mailAlso = "";         // default ""

/*
 * Which form fields are optional. It is assumed that nobody would want
 * comments to be optional.
 */
$requireName  = true;	// Require user put something in for a name?  - default true
$requireSubj  = true;	// Require user put in a subject?  - default true
$requireEmail = true;	// Require user put in a reply (from) email address? - default true

// Set size of text window for user message
$spTextRows=10; // default=10
$spTextCols=50; // default=50

// Include a reset button in the form
$spfIncludeResetButton = false;  // default false

// Show "To:" message if there's a single recipient? (The Sottwell option)
$spShowSingleRecipientTo=false; // default false

/*
 * $requireVerify is set to false, by default, for maximum portability.
 * Servers need the GD library and (I think) Freetype enabled for this to
 * work. Also, it's cumbersome for users and sometimes impossible for users
 * with disabilities. With so many other protections in SPForm, it may not
 * be necessary.
 */
$requireVerify = false;	// Require CAPTCHA-style human being verification? - default false
$useMathString = true; // if using verify, ask user to solve a math problem - default true
						// ignored if $requireVerify = false
$warnVerify = true; // default true

/*
 * Info to optionally add to emailed form. Set to true for each you want.
 * Will be stashed in X-Headers.
 */
$reportRemoteHost  = true;   // default true
$reportRemoteUser  = true;   // default true
$reportRemoteAddr  = true;   // default true
$reportRemoteIdent = true;	// Note that ident/auth is unreliable - default true
$reportOrigReferer = true;  // default true


/*
 * The following are used by the form processor, not the form Some
 * firewalls and HTTP proxy servers delete the HTTP REFERER. By setting the
 * following to "true," victims behind such misguided systems will still be
 * able to use your form.
 */
$formProcBlankRefOkay = true;    // default true

// Tell $errorsTo recipient about invalid referer hits?
$adviseOnReferer = false;  // default false

// Log invalid referer hits?
$logOnReferer = false;    // default false


// Tell 'em they're banned, or silently discard?
// You might want to change this after you have things working well for a while.
$warnBanned = true;      // default true


// Tell $errorsTo recipient about banned attempts?
$adviseOnBan = false;    //default false


// Log banned attempts?
$logOnBan = false;    // default false


// Tell $errorsTo recipient about failed verification (CAPTCHA)?
$adviseOnVerify = false;   // default false


// Log failed verifications?
$logOnVerify = false;   // default false


/*
 * The following variables are used by the form, not the form processor
 * Check HTTP_REFERER for sanity before even offering the form? Web form
 * spammers often have HTTP_REFERERS that are blank, the URL of the form
 * itself, or something entirely made up. Note: Even with the next two set
 * to false, spformproc will still check the referrer against the list of
 * allowed referrers as long as $chkFormRefNotBlank = true;
 */

// Make sure the referer isn't the form itself?
$chkFormRefNotSelf = false;  // default false

/*
 * Insist that, if there's a referer, it's our own server? Note: This can
 * cause trouble if you (or your host) rewrite the incoming URL by
 * prepending www or stripping it, or through rewrites or redirection. The
 * php REFERRER variable may not agree with MODx's idea of the referer.
 * Some users may get an "invalid referrer" message when submitting. The
 * problem will be intermittent because users can reach your site with
 * various URLs.*/
$chkFormRefOwnServer = false;  // default false

/*
 * Make sure not blank? Use $chkFormRefNotBlank with care, as some
 * firewalls and HTTP proxies delete the REFERER
 */
$chkFormRefNotBlank = false;  // default false

?>
