<?php
//error_reporting(E_ALL);
/*******************************************
File:         spform.inc.php

Snippet:       SPForm
Version: 1.0.4
$Revision: 265 $
$Author: Bob Ray $
$Date: 2009-07-02 15:42:55 -0500 (Thu, 02 Jul 2009) $
Adapted from:  Many sources but particularly scform by James Seymour and CFFormProtect by Jake Munson
Compatibility: MODX 0.9.6, 0.9.7

*******************************************/
// File: spform snippet

//get spfconfig.cfg.php file

    global $modx;

    $spformPath = "assets/snippets/spform/";

    require_once $modx->config['base_path'].$spformPath."spfconfig.cfg.php";

     if ($spfDebug) {
       $fullPath = $modx->config['base_path'].$spformPath."spfconfig.cfg.php";
       echo "<b>Path to spfconfig file:</b><br />",$fullPath,"<br />";
    }

    $verifyUrl=$modx->config['site_url'].$spformPath.'spfveriword.php';
    $lang = isset($lang)?$lang:'en';

    if ($spfDebug) {
        echo "<b>Path to lang file:</b><br />".$modx->config['base_path'].$spformPath."lang/".$lang.".inc.php<br />";
        echo "<b>Verify URL:</b><br />".$verifyUrl."<br />";
    }

    require_once $modx->config['base_path'].$spformPath."lang/".$lang.".inc.php";




    if ($spfDebug) {
       require_once $modx->config['base_path'].$spformPath."spfdebug.php";
    }


/*

   The original code for this snippet was written by James Seymour as
   scform.php. I've made extensive modifications to the code, but much of
   Jim's original code remains.

   Some changes were to integrate the package with MODx. Others were (hopefully)
   improvements I found in various other contact forms. I've also changed
   some of the original defaults and added some parameters.

   If the form works for you, James deserves most of the credit. If it doesn't,
   I probably deserve most of the blame. Please don't ask Jim for help with the
   snippet. As far as I know, he is not MODx-aware. I have left his GPL statement
   below  -- Bob Ray


   **********************************************************
   scform.php - Web page form for Simple Contact Form package
   Copyright (C) 2002-2004 by James S. Seymour (jseymour [at] LinxNet [dot] com)
   (See "License", below.)  Release 1.2.5.

   License:
      This program is free software; you can redistribute it and/or
      modify it under the terms of the GNU General Public License
      as published by the Free Software Foundation; either version 2
      of the License, or (at your option) any later version.

      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You may have received a copy of the GNU General Public License
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
      USA.

      An on-line copy of the GNU General Public License can be found
      http://www.fsf.org/copyleft/gpl.html.

*/

    // Web form spammers frequently either leave HTTP_REFERER empty, set it
    // equal to the form's own URL, or make something up out of thin air.
    // We don't do this "is it our own server" if it's blank, as the "is it
    // blank" check will get that one
    $selfChkStr = $_SERVER['PHP_SELF'];
    $serverChkStr = "http://" . $_SERVER['SERVER_NAME'];

    $referer = $_SERVER['HTTP_REFERER'];



    if(($chkFormRefNotBlank && !$_SERVER['HTTP_REFERER']) ||
       ($chkFormRefNotSelf && preg_match("#$selfChkStr$#i", $_SERVER['HTTP_REFERER'])) ||
       ($chkFormRefOwnServer && $_SERVER['HTTP_REFERER'] &&
        !preg_match("#^$serverChkStr#i", $referer)))
    {
        // Almost certainly web form spammers
        // "terminate" the page early)
        print('<div align="center">'.$spf_lang['bad-referer'].' "'.
            $_SERVER['HTTP_REFERER'] .'"</div>');
        print("</body></html>");
        exit;
    }


    if($requireVerify)

    print('<div class="spf_cookie_msg">('.$spf_lang['cookies-required'].')</div>');



echo '<div id="spf_form">';

$spformProcURL = $modx->makeUrl($spformProcID,'','','full');
echo '<form action="'.$spformProcURL.'" method="post">';

if ($requireKeyboard || $requireMouseOrKeyboard) {    // send keycount value
    echo '<input type="hidden" name="keyCount" id="keyCount" value="" />';
    echo '<script type="text/javascript">';

    require_once $spformPath."usedKeyboard.js";
    echo '</script>';

}
if ($requireMouse || $requireMouseOrKeyboard) {       // send mouse movement value
    echo '<input type="hidden" name="mouseTravel" id="mouseTravel" value="" />';

    echo '<script type="text/javascript">';

    require_once $spformPath."mouseMovement.js";
    echo '</script>';
}

if($useHiddenField) {  // double underscore in input variable name prevents autofill by Firefox and RoboForm
echo '<div class="spform_input">';
echo $spf_lang['hidden-last-name'].': ','<input type="text" name="Last__Name" size="30" /></div>';
}
if ($useTimer) {
$tm = time();  // get current time in seconds
if ($spfDebug) echo 'time = ',$tm,'<br />';
$tm += $timerOffset;  // obfuscate time
if ($spfDebug)echo 'time = ',$tm,'<br /><br />';
echo '<div class="spform_normal_input"><input type="hidden" name="tmStart" value="',$tm,'" /></div>';
}

            // Get a pseudo-random alpha-numeric string (no zeros and O's)
            function pseudo_random_string($length) {
                $string = "";
                while($length--) {
                for($indx = rand(49, 90);
                    ($indx > 57 && $indx < 65) || $indx == 79;
                    $indx = rand(49, 90))
                    ;
                $string .= chr($indx);
                }

                return($string);
            }

            // Read a line from a config file, stripping comments
            // and blank lines
            function read_file_line($fp) {
                while(($inString = fgets($fp, 2048)) != false) {
                $inString = rtrim(preg_replace('/\s*#.*/', '',
                    $inString));
                if(!empty($inString))
                    break;
                }

                return $inString;
            }

            $ms = pseudo_random_string(5);
                        $_SESSION['majik_string'] = $ms;

            // Read the contact list keys and descriptions into hash
            if(($fp = fopen($recipientFile, "r")) == false) {
                 die("Can't open data file '$recipientFile'.\n");
            }
            while($inString = read_file_line($fp)) {
                list($key, $description, $value) =
                explode(':', $inString);
                $options[$key] = $description;
            }
            fclose($fp);

            // If we've more than one choice: present a menu
            if(count($options) > 1) {
                // If we were given a single arg, that'll be the
                // selected menu item.
                echo '<p><span class="spf_prompt">'.$spf_lang['send-to'].': </span>';

                if(count($_GET) == 1)
                    $selected = strtolower(key($_GET));
                print("<span><select name=\"whoto\">\n");
                foreach($options as $key => $description) {
                print("<option ");
                if(strtolower($key) == $selected)
                    print("selected ");
                print("value=\"" . trim($key) .  "\">" .
                       trim($description) . "\n".'</option>');
                }
                print("</select></span>\n");

                echo '</p>';
            } else {
                // There'll be only one...
                echo '<p>';
                if ($spShowSingleRecipientTo) {
                    echo '<span class="spf_prompt">'.$spf_lang['send-to'].': </span>';

                    //echo '<p>';

                    foreach($options as $key => $description) {
                    print('<span class="spf__normal_input"><input type="hidden" name="whoto" value="' .
                           trim($key) . '" />' . trim($description) . "\n".'</span>');
                    }
                    echo '</p>';
                }  else {
                    foreach($options as $key => $description) {
                        //echo '<p>';
                        print('<input type="hidden" name="whoto" value="' .
                        trim($key) . "\" />\n");
                        //echo '</p>';
                    }
                    //echo '</tr>';
                }
            }

            // Used by the form processor acknowledgment to create a
            // "take me back" link.
            if(!empty($_SERVER['HTTP_REFERER'])) {
                echo "<span>";
                print("<input type=\"hidden\" name=\"orig_referer\" value=\"" .
                   $_SERVER['HTTP_REFERER'] . "\" />\n");
                echo "</span>";
            }
echo '<p><span class="spf_prompt">'.$spf_lang['your-name'].': </span>';
echo '<span class="spf_normal_input"><input type="text" name="name" size="30" /></span></p>';

echo '<p><span class="spf_prompt">'.$spf_lang['email-address'].': </span>';
echo '<span class="spf_normal_input"><input type="text" name="email" size="30" /></span></p>';

echo '<p><span class="spf_prompt">'.$spf_lang['subject'].': </span>';
echo '<span class="spf_normal_input"><input type="text" name="subject" size="30" /></span></p>';

        // Are we requiring CAPTCHA-style "is a human" verification?
        if($requireVerify) {   // $verifyUrl set at top of this file

            // make sure we can  find the core files

            if (file_exists("manager/includes/config.inc.php")) {  //we're in 0.9.6
                $spfModxVersion=6;
            } else if (file_exists("config.core.php")) {  // we're in 0.9.7
                $spfModxVersion=7;
            } else {   //we're toast
              echo "<br>Can't find any core file in spconfig.cfg.php<br>Can't use CAPTCHA.";
              exit();
            }

            echo '<p><span class="spf_verify_msg">'.$spf_lang['verification'].': </span></p>';
            echo '<p><img  src="',$verifyUrl,'  "  alt="Verification string image" /></p>';

            echo '<p>';
            if ($useMathString) {
                echo '<span class="spf_verify_prompt">'.$spf_lang['math-problem'].'&nbsp;</span>';
            }
            else {
                echo '<span class="spf_verify_prompt">'.$spf_lang['veri-string'].'&nbsp;</span>';
            }
            echo '<span class="spf_normal_input"><input type="text" name="verify" size="10" /></span>';

            echo '</p>';


        }
echo '<p><span class="spf_prompt">'.$spf_lang['enter-comments'].'</span></p>';
echo '<p><textarea name="comments" rows="'.$spTextRows.'" cols="'.$spTextCols.'"></textarea></p>';
echo '<p><input type="submit" name="s" value="'.$spf_lang['submit'].'" />&nbsp;';
if ($spfIncludeResetButton) {
    echo '<input type="reset" value="'.$spf_lang['reset'].'" />';
}
echo '</p>';
echo '</form>';

echo '</div>'; // end of spf_form div


?>